%************************************************
% comp_ls.m: Comparison to least-squares method *
%************************************************
clear
close all
x=[0.25:0.25:3];      % range of measurement
sigma0=1;             % standard deviation parameter for measurement noise
randn('state',sum(999*clock));
y0=-3*x+2*x.^2;
N=length(x);
y=y0+sigma0*randn(1,N)./x;   % generation of contaminated measurements
A(1,1)=sum((x.^2).*(x.^2));
A(1,2)=sum((x.^3).*(x.^2));
A(2,1)=A(1,2);
A(2,2)=sum((x.^4).*(x.^2));
b(1)=sum(y.*x.*(x.^2));
b(2,1)=sum(y.*(x.^2).*(x.^2));
theta=A\b;
plot(x,y0,'--')
hold on
plot(x,y,'x')
plot(x,theta(1)*x+theta(2)*x.^2,'r')
plot(x(6)+[0 0.68],[theta(1)*x(6)+theta(2)*x(6)^2 -0.8])
h = text(2.5,-0.8,'Bayesian');
set(h,'horizontalalignment','center','fontsize',15);

%%%%%%% Least squares %%%%%%%%%%%%%
A(1,1)=sum(x.^2);
A(1,2)=sum(x.^3);
A(2,1)=A(1,2);
A(2,2)=sum(x.^4);
b(1)=sum(y.*x);
b(2,1)=sum(y.*(x.^2));
theta=A\b;
plot(x,theta(1)*x+theta(2)*x.^2)

plot(x(6)+[0 -0.3],[theta(1)*x(6)+theta(2)*x(6)^2 4.2])
h = text(1.2,4.2,'LS');
set(h,'horizontalalignment','center','fontsize',15);

xlabel('x')
ylabel('y or Q')