%*******************************************
% m_id1.m (1 measured eigenvalue)          *
% Example for identifiability in Chapter 2 *
%*******************************************
close all
clear
% Parameters definition
A0=[2 1;
    1 1];
sigman=0.05; % noise standard deviation
L=eig(A0);
L0=min(L);   % actual eigenvalue (smaller)
randn('state',sum(999*clock));
Lm=L0+sigman*L0*randn(1,5); % measurements
x=[0.92:0.005:1.2]; Nx=length(x);
y=[0.82:0.005:1.1]; Ny=length(y);

% Draw posterior PDF
for pp=1:Nx
    for qq=1:Ny
        A=[x(pp)+y(qq) y(qq);
                 y(qq) y(qq)];
        LAtemp=eig(A);
        LA=min(LAtemp);
        J(qq,pp)=sum((LA-Lm).^2);
    end
end
p=(2*pi)^(-5/2)*(sigman*L0)^(-5)*exp(-J/2/(sigman*L0)^2);
mesh(x,y,p)
xlabel('\theta_1')
ylabel('\theta_2')
zlabel('p(D|\theta,C)')

y=0.4:0.025:2.2;
x=(mean(Lm)^2-2*y*mean(Lm))./(mean(Lm)-y);
figure
plot(x,y)
xlabel('\theta_1')
ylabel('\theta_2')