%*******************************************
% m_id2.m  (2 measured eigenvalues)        *
% Example for identifiability in Chapter 2 *
% By KV Yuen                               *
%*******************************************
close all
clear
% Parameters definition
A0=[2 1;
    1 1];
sigman=0.05;
L=eig(A0);
L0=sort(L); % actual eigenvalue (smaller)
randn('state',sum(999*clock));
Lm1=L0(1)+sigman*L0(1)*randn(1,5); % measurements
Lm2=L0(2)+sigman*L0(2)*randn(1,5); % measurements

x=[0.84:0.04:0.92 0.93:0.01:1.14 1.16:0.04:1.72 1.73:0.01:2.03 2.04:0.02:2.22]; Nx=length(x);
y=[0.42:0.04:0.46 0.47:0.01:0.57 0.58:0.04:0.86 0.87:0.01:1.03 1.04:0.02:1.1]; Ny=length(y);

%x=[0.84:0.005:2.22]; Nx=length(x);
%y=[0.42:0.005:1.1]; Ny=length(y);
% Draw posterior PDF
for pp=1:Nx
    for qq=1:Ny
        A=[x(pp)+y(qq) y(qq);
                 y(qq) y(qq)];
        LAtemp=eig(A);
        LA=sort(LAtemp);
        J(qq,pp)=sum((LA(1)-Lm1).^2)/(L0(1)*sigman)^2+sum((LA(2)-Lm2).^2)/(L0(2)*sigman)^2;
    end
end
p=(2*pi)^(-10/2)*(L0(1)*sigman)^(-5)*(L0(2)*sigman)^(-5)*exp(-J/2);
mesh(x,y,p)
xlabel('\theta_1')
ylabel('\theta_2')
zlabel('p(D|\theta,C)')

figure
contour(x,y,p)
shg
xlabel('\theta_1')
ylabel('\theta_2')