function [nlnp,g]=pnonsta(pa);
global T dt Yt nlnpmin dis Np
w=pa(1);z=pa(2);S=pa(3);wd=w*(1-z^2)^0.5;
SIGMA22=zeros(Np);
for n=1:Np
    R=pi*S/2/z/w^3*exp(-z*w*[0:Np-n]*dt).*(cos(wd*[0:Np-n]*dt)+...
      z*w/wd*sin(wd*[0:Np-n]*dt))-pi*S/2/z/w^3*exp(-z*w*[2*n:n+Np]*dt).*...
      (w^2/wd^2*cos(wd*[0:Np-n]*dt)+z*w/wd*sin(wd*[2*n:n+Np]*dt)-...
      z^2*w^2/wd^2*cos(wd*[2*n:n+Np]*dt)); % computation of correlation fxn
    R(1)=R(1)+pa(4)^2;
    SIGMA22(Np-n+1,Np-n+1:-1:1)=R(1,1:Np-n+1);
    SIGMA22(Np-n+1:-1:1,Np-n+1)=R(1,1:Np-n+1)';
end
% joint PDF for the first Np points
nlnp=0.5*log(det(SIGMA22))+0.5*Yt(Np:-1:1)'*inv(SIGMA22)*Yt(Np:-1:1); 
for n=Np+1:T/dt
    R=pi*S/2/z/w^3*exp(-z*w*[0:Np]*dt).*(cos(wd*[0:Np]*dt)+...
   z*w/wd*sin(wd*[0:Np]*dt))-pi*S/2/z/w^3*exp(-z*w*[2*n:-1:2*n-Np]*dt).*...
      (w^2/wd^2*cos(wd*[0:Np]*dt)+z*w/wd*sin(wd*[2*n:-1:2*n-Np]*dt)-...
      z^2*w^2/wd^2*cos(wd*[2*n:-1:2*n-Np]*dt)); % computation of correlation fxn
    R(1)=R(1)+pa(4)^2;
    VARI(n)=R(1)-R(2:end)*inv(SIGMA22)*R(2:end)';
    Mean(n)=R(2:end)*inv(SIGMA22)*Yt(n-1:-1:n-Np);
    % conditional PDFs
    nlnp=nlnp+0.5*log(VARI(n))+0.5*(Yt(n)-Mean(n))^2/VARI(n);
    SIGMA22=[R(1:Np);R(2:Np)' SIGMA22(1:Np-1,1:Np-1)];
end
g=0;
if and(and((dis==1),(nlnp<nlnpmin)),(nlnp>-9e99))
   disp(['Parameters:',num2str(round(pa*1e4)/1e4)]);
   disp(['-ln(p)=    ',num2str(nlnp)]);
   nlnpmin=nlnp;
end
